<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Observation_EntityRepository &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Static SystemConfig" href="../configs/staticsystemconfig.html" />
    <link rel="prev" title="Observation_Log" href="observation_log.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../30_configs_in_depth.html">Configs in Depth</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../configs/profilescatalog.html">ProfilesCatalog</a></li>
<li class="toctree-l2"><a class="reference internal" href="../configs/scenario.html">Scenario</a></li>
<li class="toctree-l2"><a class="reference internal" href="../configs/scenario_api_support.html">Scenario API Support</a></li>
<li class="toctree-l2"><a class="reference internal" href="../configs/scenery.html">Scenery</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../configs/simulationconfig.html">SimulationConfig</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="../configs/simulationconfig.html#profilescatalog">ProfilesCatalog</a></li>
<li class="toctree-l3"><a class="reference internal" href="../configs/simulationconfig.html#experiment">Experiment</a></li>
<li class="toctree-l3"><a class="reference internal" href="../configs/simulationconfig.html#scenario">Scenario</a></li>
<li class="toctree-l3"><a class="reference internal" href="../configs/simulationconfig.html#environment">Environment</a></li>
<li class="toctree-l3 current"><a class="reference internal" href="../configs/simulationconfig.html#observations">Observations</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="observation_log.html">Observation_Log</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Observation_EntityRepository</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="../configs/simulationconfig.html#spawners">Spawners</a></li>
<li class="toctree-l3"><a class="reference internal" href="../configs/simulationconfig.html#full-example">Full Example</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../configs/staticsystemconfig.html">Static SystemConfig</a></li>
<li class="toctree-l2"><a class="reference internal" href="../configs/systemconfigblueprint.html">SystemConfigBlueprint</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/10_ide_support.html">IDE Support</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../developer_information/30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../30_configs_in_depth.html">Configs in Depth</a></li>
          <li class="breadcrumb-item"><a href="../configs/simulationconfig.html">SimulationConfig</a></li>
      <li class="breadcrumb-item active">Observation_EntityRepository</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/user_guide/outputs/observation_repository.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="observation-entityrepository">
<span id="id1"></span><h1>Observation_EntityRepository<a class="headerlink" href="#observation-entityrepository" title="Link to this heading"></a></h1>
<p>This observer logs all entities generated for an experiment, split by run and/or persistence.
In the following, the parametrization and generated outputs of the <code class="docutils literal notranslate"><span class="pre">Observation_EntityRepository</span></code> observer are described.</p>
<section id="parametrization">
<span id="observation-entityrepository-parametrization"></span><h2>Parametrization<a class="headerlink" href="#parametrization" title="Link to this heading"></a></h2>
<p>Following parameters are supported:</p>
<table class="tight-table docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Parameter</p></th>
<th class="head"><p>Type</p></th>
<th class="head"><p>Description</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>FilenamePrefix</p></td>
<td><p>String</p></td>
<td><p>(Optional) Prefix for the output files.
Defaults to <code class="docutils literal notranslate"><span class="pre">Repository</span></code> resulting e.g. in <code class="docutils literal notranslate"><span class="pre">Repository_Run_00.csv</span></code>.</p></td>
</tr>
<tr class="row-odd"><td><p>WritePersistentEntities</p></td>
<td><p>String</p></td>
<td><p>Defines how persistent, ie cross-run entities such as stationary objects, are logged</p>
<p>Options:</p>
<ul class="simple">
<li><p><strong>Consolidated</strong> (default): Logged together with non persistent entities and hence duplicated for each run.</p></li>
<li><p><strong>Separate</strong>: Written once into <code class="docutils literal notranslate"><span class="pre">{FilenamePrefix}_Persistent.csv</span></code></p></li>
<li><p><strong>Skip</strong>: No output.</p></li>
</ul>
</td>
</tr>
</tbody>
</table>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>The visualization is searching for files with the default <code class="docutils literal notranslate"><span class="pre">Repository</span></code> prefix, so don’t change it unless you have a reason to.</p>
</div>
<p><strong>Example</strong></p>
<div class="highlight-xml notranslate"><div class="highlight"><pre><span></span><span class="w">      </span><span class="nt">&lt;Library&gt;</span>Observation_EntityRepository<span class="nt">&lt;/Library&gt;</span>
<span class="w">      </span><span class="nt">&lt;Parameters&gt;</span>
<span class="w">        </span><span class="cm">&lt;!-- If &quot;FilenamePrefix&quot; is skipped, defaults to Value=&quot;Repository&quot; --&gt;</span>
<span class="w">        </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;FilenamePrefix&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Repository&quot;</span><span class="nt">/&gt;</span>
<span class="w">        </span><span class="cm">&lt;!-- If &quot;WritePersistentEntities&quot; is skipped, defaults to Value=&quot;Consolidated&quot;</span>
<span class="cm">             Options: </span>
<span class="cm">             - Consolidated: Concatenate with {FilenamePrefix}_Run_###.csv for each run</span>
<span class="cm">             - Separate: Write to {FilenamePrefix}_Persistent.csv</span>
<span class="cm">             - Skip: No output for persistent entities</span>
<span class="cm">        --&gt;</span>
<span class="w">        </span><span class="nt">&lt;String</span><span class="w"> </span><span class="na">Key=</span><span class="s">&quot;WritePersistentEntities&quot;</span><span class="w"> </span><span class="na">Value=</span><span class="s">&quot;Consolidated&quot;</span><span class="nt">/&gt;</span>
<span class="w">      </span><span class="nt">&lt;/Parameters&gt;</span>
</pre></div>
</div>
</section>
<section id="output-files">
<h2>Output Files<a class="headerlink" href="#output-files" title="Link to this heading"></a></h2>
<section id="repository-run-csv">
<span id="observation-entityrepository-run"></span><h3>Repository_Run_###.csv<a class="headerlink" href="#repository-run-csv" title="Link to this heading"></a></h3>
<p>This file contains information about entities, which exist only within the given run.
In other words, <code class="docutils literal notranslate"><span class="pre">Repository_Run_000.csv</span></code> will contain all moving objects, spawned within the first run (zero-based index).</p>
<p><strong>Example</strong></p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>id</p></th>
<th class="head"><p>group</p></th>
<th class="head"><p>source</p></th>
<th class="head"><p>version</p></th>
<th class="head"><p>name</p></th>
<th class="head"><p>secondary id</p></th>
<th class="head"><p>type</p></th>
<th class="head"><p>subtype</p></th>
<th class="head"></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>0</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td><p>Ego</p></td>
<td></td>
<td><p>Ego</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>1</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td><p>TF</p></td>
<td></td>
<td><p>Scenaro</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>2</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td><p>S1</p></td>
<td></td>
<td><p>Scenaro</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>3</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td><p>S2</p></td>
<td></td>
<td><p>Scenaro</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>4</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td><p>S3</p></td>
<td></td>
<td><p>Scenaro</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>5</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td></td>
<td></td>
<td><p>Common</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-even"><td><p>6</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td></td>
<td></td>
<td><p>Common</p></td>
<td></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>7</p></td>
<td><p>MovingObject</p></td>
<td><p>OpenSCENARIO</p></td>
<td></td>
<td></td>
<td></td>
<td><p>Common</p></td>
<td></td>
<td></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>By convention, moving objects start with id 0.</p>
</div>
<p>If <code class="docutils literal notranslate"><span class="pre">WritePersistentEntities</span></code> is set to <code class="docutils literal notranslate"><span class="pre">Consolidated</span></code>, each file will also contain information about stationary objects, described below.</p>
</section>
<section id="repository-persistent-csv">
<span id="observation-entityrepository-persistent"></span><h3>Repository_Persistent.csv<a class="headerlink" href="#repository-persistent-csv" title="Link to this heading"></a></h3>
<p>This file contains information about entities, which exist in every single run.
This includes mainly both objects (starting at 100000) and road elements (starting at 200000), defined by the <a class="reference internal" href="../configs/scenery.html#scenery"><span class="std std-ref">Scenery</span></a>.</p>
<p><strong>Example</strong></p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>id</p></th>
<th class="head"><p>group</p></th>
<th class="head"><p>source</p></th>
<th class="head"><p>version</p></th>
<th class="head"><p>name</p></th>
<th class="head"><p>secondary id</p></th>
<th class="head"><p>type</p></th>
<th class="head"><p>subtype</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>100000</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>Barrier</p></td>
<td><p>barrier_01</p></td>
<td><p>obstacle</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>100001</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_01</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>100002</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_01</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>100003</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_01</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>100004</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_01</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>100005</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_01</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>100006</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_02</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>100007</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_02</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>100008</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_02</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>100009</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_02</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>100010</p></td>
<td><p>StationaryObject</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>GuardRail</p></td>
<td><p>guardrail_02</p></td>
<td><p>railing</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>200000</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>LaneRoadMark</p></td>
<td></td>
<td><p>Solid</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>200001</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>LaneRoadMark</p></td>
<td></td>
<td><p>Solid</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>200002</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>Lane</p></td>
<td><p>-3</p></td>
<td><p>Driving</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>200003</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>LaneRoadMark</p></td>
<td></td>
<td><p>Broken</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>200004</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>Lane</p></td>
<td><p>-2</p></td>
<td><p>Driving</p></td>
<td></td>
</tr>
<tr class="row-even"><td><p>200005</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>LaneRoadMark</p></td>
<td></td>
<td><p>Broken</p></td>
<td></td>
</tr>
<tr class="row-odd"><td><p>200006</p></td>
<td><p>Others</p></td>
<td><p>OpenDRIVE</p></td>
<td><p>1.6</p></td>
<td><p>Lane</p></td>
<td><p>-1</p></td>
<td><p>Driving</p></td>
<td></td>
</tr>
</tbody>
</table>
<p>Information coming from the source <a class="reference external" href="https://www.asam.net/standards/detail/opendrive/">OpenDRIVE</a> are mapped in the following manner:</p>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Attribute</p></th>
<th class="head"><p>Column</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p>name</p></td>
<td><p>name</p></td>
</tr>
<tr class="row-odd"><td><p>id</p></td>
<td><p>secondary id</p></td>
</tr>
<tr class="row-even"><td><p>type</p></td>
<td><p>type</p></td>
</tr>
<tr class="row-odd"><td><p>subtype</p></td>
<td><p>subtype</p></td>
</tr>
</tbody>
</table>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Repeated OpenDRIVE objects are internally split into individual objects.
E.g. a single guard rail object in OpenDRIVE, is split into individual openPASS objects having consecutive ids.
In the example above, the OpenDRIVE object with (secondary) id <code class="docutils literal notranslate"><span class="pre">guardrail_01</span></code> is split into 5 individual openPASS objects with the closed id range from 100001 to 100005.</p>
</div>
</section>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="observation_log.html" class="btn btn-neutral float-left" title="Observation_Log" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../configs/staticsystemconfig.html" class="btn btn-neutral float-right" title="Static SystemConfig" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>